// WordSnippet v1.0
// Written by David J. Stein, Esq. See "License.html" for terms and conditions of use.
//
// This module contains the code for the WordSnippet configurator. (All of the interesting stuff happens in the Connect.cs file, so you may want to look there instead.)

#region Using declarations

using System;
using System.Drawing;
using System.Collections;
using System.Configuration;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;

#endregion

namespace WordSnippet_Configurator {

	public class WordSnippetConfigurator : System.Windows.Forms.Form {

		#region Variables, initialization code, and Main

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtWordSnippetFolder;
		private System.Windows.Forms.TextBox txtOutlookSnippetFolder;
		private System.Windows.Forms.Button btnSaveExit;
		private System.Windows.Forms.Button btnExit;
		private System.Windows.Forms.CheckBox checkUseWithWord;
		private System.Windows.Forms.CheckBox checkUseWithOutlook;
		private System.ComponentModel.Container components = null;

		public WordSnippetConfigurator() {
			InitializeComponent();
		}

		[STAThread]
		static void Main() {
			Application.Run(new WordSnippetConfigurator());
		}

		#endregion

		#region Uninteresting Windows Form Designer generated code
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(WordSnippetConfigurator));
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.txtWordSnippetFolder = new System.Windows.Forms.TextBox();
			this.txtOutlookSnippetFolder = new System.Windows.Forms.TextBox();
			this.btnSaveExit = new System.Windows.Forms.Button();
			this.btnExit = new System.Windows.Forms.Button();
			this.checkUseWithWord = new System.Windows.Forms.CheckBox();
			this.checkUseWithOutlook = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(168, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Microsoft Word snippet folder";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(168, 23);
			this.label2.TabIndex = 1;
			this.label2.Text = "Microsoft Outlook snippet folder";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// txtWordSnippetFolder
			// 
			this.txtWordSnippetFolder.Location = new System.Drawing.Point(176, 32);
			this.txtWordSnippetFolder.Name = "txtWordSnippetFolder";
			this.txtWordSnippetFolder.Size = new System.Drawing.Size(312, 20);
			this.txtWordSnippetFolder.TabIndex = 2;
			this.txtWordSnippetFolder.Text = "C:\\Program Files\\WordSnippet\\WordSnippets";
			// 
			// txtOutlookSnippetFolder
			// 
			this.txtOutlookSnippetFolder.Location = new System.Drawing.Point(176, 96);
			this.txtOutlookSnippetFolder.Name = "txtOutlookSnippetFolder";
			this.txtOutlookSnippetFolder.Size = new System.Drawing.Size(312, 20);
			this.txtOutlookSnippetFolder.TabIndex = 3;
			this.txtOutlookSnippetFolder.Text = "C:\\Program Files\\WordSnippet\\OutlookSnippets";
			// 
			// btnSaveExit
			// 
			this.btnSaveExit.Location = new System.Drawing.Point(120, 136);
			this.btnSaveExit.Name = "btnSaveExit";
			this.btnSaveExit.Size = new System.Drawing.Size(120, 23);
			this.btnSaveExit.TabIndex = 6;
			this.btnSaveExit.Text = "Save and Exit";
			this.btnSaveExit.Click += new System.EventHandler(this.btnSaveExit_Click);
			// 
			// btnExit
			// 
			this.btnExit.Location = new System.Drawing.Point(256, 136);
			this.btnExit.Name = "btnExit";
			this.btnExit.Size = new System.Drawing.Size(120, 23);
			this.btnExit.TabIndex = 7;
			this.btnExit.Text = "Exit Without Saving";
			this.btnExit.Click += new System.EventHandler(this.btnExit_Click);
			// 
			// checkUseWithWord
			// 
			this.checkUseWithWord.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.checkUseWithWord.Checked = true;
			this.checkUseWithWord.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkUseWithWord.Location = new System.Drawing.Point(128, 8);
			this.checkUseWithWord.Name = "checkUseWithWord";
			this.checkUseWithWord.Size = new System.Drawing.Size(240, 24);
			this.checkUseWithWord.TabIndex = 9;
			this.checkUseWithWord.Text = "Use WordSnippet with Microsoft Word";
			// 
			// checkUseWithOutlook
			// 
			this.checkUseWithOutlook.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.checkUseWithOutlook.Checked = true;
			this.checkUseWithOutlook.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkUseWithOutlook.Location = new System.Drawing.Point(128, 72);
			this.checkUseWithOutlook.Name = "checkUseWithOutlook";
			this.checkUseWithOutlook.Size = new System.Drawing.Size(240, 24);
			this.checkUseWithOutlook.TabIndex = 10;
			this.checkUseWithOutlook.Text = "Use WordSnippet with Microsoft Outlook";
			// 
			// WordSnippetConfigurator
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(496, 166);
			this.Controls.Add(this.checkUseWithOutlook);
			this.Controls.Add(this.checkUseWithWord);
			this.Controls.Add(this.btnExit);
			this.Controls.Add(this.btnSaveExit);
			this.Controls.Add(this.txtOutlookSnippetFolder);
			this.Controls.Add(this.txtWordSnippetFolder);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "WordSnippetConfigurator";
			this.Text = "WordSnippet Options";
			this.Load += new System.EventHandler(this.WordSnippetConfigurator_Load);
			this.ResumeLayout(false);

		}
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		#endregion

		#region Event handlers

		private void WordSnippetConfigurator_Load(object sender, System.EventArgs e) {
			// This function loads the configurator settings from the WordSnippet.exe.config file.
			AppSettingsReader reader = new AppSettingsReader();
			// read Word snippets directory
			try {
				checkUseWithWord.CheckState = reader.GetValue("EnableWordSnippets", typeof(System.String)).ToString() == "True" ? CheckState.Checked : CheckState.Unchecked;
				txtWordSnippetFolder.Text = reader.GetValue("WordSnippets", typeof(System.String)).ToString();
			} catch {
				checkUseWithWord.CheckState = CheckState.Checked;
				txtWordSnippetFolder.Text = @"C:\Program Files\WordSnippet\Word Snippets";
			}
			// read Outlook snippets directory
			try {
				checkUseWithOutlook.CheckState = reader.GetValue("EnableOutlookSnippets", typeof(System.String)).ToString() == "True" ? CheckState.Checked : CheckState.Unchecked;
				txtOutlookSnippetFolder.Text = reader.GetValue("OutlookSnippets", typeof(System.String)).ToString();
			} catch {
				checkUseWithOutlook.CheckState = CheckState.Checked;
				txtOutlookSnippetFolder.Text = @"C:\Program Files\WordSnippet\Outlook Snippets";
			}
		}

		private void btnExit_Click(object sender, System.EventArgs e) {
			Close();
		}

		private void btnSaveExit_Click(object sender, System.EventArgs e) {
			WriteSettings();
			Close();
		}

		#endregion

		#region Other functions

		private void WriteSettings() {
			// This function writes a new WordSnippet.exe.config file.
			XmlTextWriter writer = new System.Xml.XmlTextWriter("WordSnippet.exe.config", System.Text.Encoding.UTF8);
			writer.Formatting = Formatting.Indented;
			writer.Indentation = 1;
			writer.IndentChar = ' ';
			writer.WriteStartDocument();
			writer.WriteStartElement("configuration");
			writer.WriteStartElement("appSettings");

			// write snippet folder settings
			writer.WriteComment("EnableWordSnippets determines whether WordSnippet is available in Word.");
			writer.WriteRaw("\r\n  <add key=\"EnableWordSnippets\" value=\"" + (this.checkUseWithWord.CheckState == CheckState.Checked ? "True" : "False") + "\" />\r\n  ");
			writer.WriteComment("WordSnippets sets the folder for snippets accessible in Word.");
			writer.WriteRaw("\r\n  <add key=\"WordSnippets\" value=\"" + txtWordSnippetFolder.Text + "\" />\r\n  ");
			writer.WriteComment("EnableOutlookSnippets determines whether WordSnippet is available in Outlook.");
			writer.WriteRaw("\r\n  <add key=\"EnableOutlookSnippets\" value=\"" + (this.checkUseWithOutlook.CheckState == CheckState.Checked ? "True" : "False") + "\" />\r\n  ");
			writer.WriteComment("OutlookSnippets sets the folder for snippets accessible in Outlook.");
			writer.WriteRaw("\r\n  <add key=\"OutlookSnippets\" value=\"" + txtOutlookSnippetFolder.Text + "\" />\r\n  ");

			// close document
			writer.WriteEndElement();
			writer.WriteEndElement();
			writer.Close();
		}

		#endregion

	}
}
